/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package cz.muni.fi.beans;

import cz.muni.fi.entities.OrderEntity;
import cz.muni.fi.entities.OrderStateType;
import java.math.BigDecimal;
import java.util.Date;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;

/**
 *
 * @author Petr
 */
@Stateless
public class OrderBean implements OrderLocal {
    @PersistenceContext
    private EntityManager em;

    public long createOrder(long creator, String itemName, BigDecimal itemPrice, int quantity) {
        OrderEntity order = new OrderEntity(creator, itemName, quantity, OrderStateType.NEW, new Date());
        this.persist(order);
        return order.getId();
    }

    public void setApprover(long orderId, String approverRole) {
        this.getOrderById(orderId).setApproverRole(approverRole);
    }

    public void setOrderState(long orderId, OrderStateType newState) {
        this.getOrderById(orderId).setStateType(newState);
    }

    public void persist(Object object) {
        em.persist(object);
    }
    
    public OrderEntity getOrderById(long id) {
        return em.find(OrderEntity.class, id);
    }
 
}
